import c4d, os
from c4d import gui

from texpath import ids
from texpath import worker 

class MainDialog(gui.GeDialog):
        method = ids.COMBO_METHOD_CHILD1
        path    = ""
        path2   = ""
       
        def CreateLayout(self):
           
            
            #creat the layout of the dialog  
            self.SetTitle(c4d.plugins.GeLoadString(ids.STR_TITLE))             
            
            # TAB
            self.TabGroupBegin(ids.TAB_ID1, c4d.BFH_SCALEFIT, tabtype=c4d.TAB_TABS) 

            self.CreatePage1()
            
 
                
            self.CreatePage2()         
   
            # Tab END
            self.GroupEnd()
                  
            return True
        
        
        
        
        def CreatePage1(self):
            # Page 1
            self.GroupBegin(ids.TAB_GROUP_ID1, c4d.BFH_SCALEFIT, 1, 3, title="Texture Path Replace") 
            self.GroupBorderSpace(3,3,3,3)
            
            # Page 1 Group 1
            self.GroupBegin(ids.TAB_GROUP_ID11, c4d.BFH_SCALEFIT, 3, 1, title="teil1")        
            self.AddStaticText(ids.STATIC_TEXT_PATH, c4d.BFH_LEFT, name="Texture Path: ")
            self.AddEditText(ids.EDIT_TEXT_PATH, c4d.BFH_SCALEFIT)
            self.AddButton(ids.BUTTON_LOAD, c4d.BFH_RIGHT, name="...")                
            self.GroupEnd() 
            
            # Page 1 Group 2
            self.GroupBegin(ids.TAB_GROUP_ID12, c4d.BFH_SCALEFIT, 1, 1,title="teil2") 
            self.AddStaticText(ids.STATIC_TEXT_MESSAGE, c4d.BFH_SCALEFIT, name="Path doesn't exist - please enter a valid path", borderstyle=5)
            self.GroupEnd() 
            
            # Page 1 Group 3
            self.GroupBegin(ids.TAB_GROUP_ID13, c4d.BFH_SCALEFIT, 1, 1,title="teil3")        
            self.AddButton(ids.BUTTON_SET, c4d.BFH_SCALEFIT, name="Set texture Path")                    
            self.GroupEnd()
            
            # Page 1 END  
            self.GroupEnd() 
            
            return True
            
            
            
        def CreatePage2(self): 
            
            # Page 2
            self.GroupBegin(ids.TAB_GROUP_ID2, c4d.BFH_SCALEFIT, 1, 3, title="Texture copier")
            self.GroupBorderSpace(3,3,3,3)        
            
            # Page 2 Group 1
            self.GroupBegin(ids.TAB_GROUP_ID22, c4d.BFH_SCALEFIT, 3, 1, title="teil1")  
            self.AddComboBox(ids.COMBO_METHOD, c4d.BFH_SCALEFIT) 
            self.AddChild(ids.COMBO_METHOD, ids.COMBO_METHOD_CHILD1, "Copy all textures in project to the relative tex folder")  
            self.AddChild(ids.COMBO_METHOD, ids.COMBO_METHOD_CHILD2, "Copy all textures in project to a specific folder")  
             
            self.GroupEnd() 
            
            if self.method == ids.COMBO_METHOD_CHILD2 :
                # Page 2 Group 2
                self.GroupBegin(ids.TAB_GROUP_ID22, c4d.BFH_SCALEFIT, 3, 1, title="teil2")        
                self.AddStaticText(ids.STATIC_TEXT_PATH2, c4d.BFH_LEFT, name="Texture Path: ")
                self.AddEditText(ids.EDIT_TEXT_PATH2, c4d.BFH_SCALEFIT)
                self.AddButton(ids.BUTTON_LOAD2, c4d.BFH_RIGHT, name="...")                
                self.GroupEnd() 
                
                # Page 2 Group 3
                self.GroupBegin(ids.TAB_GROUP_ID23, c4d.BFH_SCALEFIT, 1, 1,title="teil3") 
                self.AddStaticText(ids.STATIC_TEXT_MESSAGE2, c4d.BFH_SCALEFIT, name="Path doesn't exist - please enter a valid path", borderstyle=5)
                self.GroupEnd() 
            
            # Page 2 Group 4
            self.GroupBegin(ids.TAB_GROUP_ID24, c4d.BFH_SCALEFIT, 1, 1,title="teil4")        
            self.AddButton(ids.BUTTON_SET2, c4d.BFH_SCALEFIT, name="Copy textures")                   
            self.GroupEnd()

            # Page 2 END
            self.GroupEnd()
            
            return True
   
        def InitValues(self):
            #initiate the gadgets with values
            self.SetDefaultColor(ids.STATIC_TEXT_MESSAGE, c4d.COLOR_TEXT, c4d.Vector(200, 0, 0))  
            self.Enable(ids.BUTTON_SET, False) 
            self.SetDefaultColor(ids.STATIC_TEXT_MESSAGE2, c4d.COLOR_TEXT, c4d.Vector(200, 0, 0))  
            #self.Enable(ids.BUTTON_SET2, False)            
            self.SetLong(ids.COMBO_METHOD, self.method)
            return True
       
        def Command(self, id, msg):

            # "Button Load"
            if id==ids.BUTTON_LOAD:
                self.SetString(ids.EDIT_TEXT_PATH,c4d.storage.LoadDialog(title="Select texture folder...", flags=c4d.FILESELECT_DIRECTORY))
                self.path = self.GetString(ids.EDIT_TEXT_PATH)
                worker.checkPath(self.path,self,ids.BUTTON_SET,ids.STATIC_TEXT_MESSAGE)   
                
            if id==ids.BUTTON_LOAD2:
                self.SetString(ids.EDIT_TEXT_PATH2,c4d.storage.LoadDialog(title="Select texture folder...", flags=c4d.FILESELECT_DIRECTORY))
                self.path2 = self.GetString(ids.EDIT_TEXT_PATH2)
                worker.checkPath(self.path2,self,ids.BUTTON_SET2,ids.STATIC_TEXT_MESSAGE2)  
                
            # "Button Set"
            if id==ids.BUTTON_SET:
                worker.replaceTexturepath(self.path)
                #self.Close()
                
            # "Button Set2"
            if id==ids.BUTTON_SET2:
                if self.method == ids.COMBO_METHOD_CHILD1:  
                    doc= c4d.documents.GetActiveDocument()   
                    mypath = doc.GetDocumentPath()+"\\tex"
                    if not os.path.isdir(mypath):
                        os.makedirs(mypath)

                                   
                    worker.copyTextures(mypath)
                    worker.replaceTexturepath("")
                    
                else:
                    worker.copyTextures(self.path2)
                
                
                #self.Close()
                 
            
            # "Edit Text Path Changes"    
            if id==ids.EDIT_TEXT_PATH:
                self.path = self.GetString(ids.EDIT_TEXT_PATH)
                worker.checkPath(self.path,self,ids.BUTTON_SET,ids.STATIC_TEXT_MESSAGE)   
                
            if id==ids.EDIT_TEXT_PATH2:
                self.path2 = self.GetString(ids.EDIT_TEXT_PATH2)
                worker.checkPath(self.path2,self,ids.BUTTON_SET2,ids.STATIC_TEXT_MESSAGE2)   
                
            if id==ids.COMBO_METHOD:
                self.method = self.GetLong(ids.COMBO_METHOD)
                self.LayoutFlushGroup(ids.TAB_GROUP_ID2)
                self.CreatePage2()
                self.InitValues()
                self.LayoutChanged(ids.TAB_GROUP_ID2) 
                
                if self.method == ids.COMBO_METHOD_CHILD1:
                    self.Enable(ids.BUTTON_SET2, True)
                else:
                    self.Enable(ids.BUTTON_SET2, False)
                  
   
            return True
