import c4d, os, shutil
from c4d import gui, plugins, bitmaps, documents
from texpath import ids


############################################################
# Copy Textures to a Path
############################################################
def copyTextures(path):
    doc= c4d.documents.GetActiveDocument()
    textures = doc.GetAllTextures()
    notfound = []
    for t in textures:
        filename = os.path.basename(t[1]) 
        dirname = os.path.dirname(t[1])
        complete = t[1]
        if dirname == "":
            complete = doc.GetDocumentPath()+"\\tex\\"+filename
            complete2 = doc.GetDocumentPath()+"\\"+filename
            try:
                shutil.copy2(complete, path+"\\"+filename) 
            except:
                print "gibts nicht"
                #notfound.append(t[1])
            
            try: 
                shutil.copy2(complete2, path+"\\"+filename)
            except:
                print "gibts auch nicht"
                notfound.append(t[1])
                 
        else:
            shutil.copy2(complete, path+"\\"+filename) 
    nftext=""    
    for nf in notfound:nftext = nftext+nf+"\n"
    gui.MessageDialog("following textures were not found: \n"+nftext)



############################################################
# Checks Path and changes Layout
############################################################
def checkPath(path, geDialog, button, text):
    if os.path.exists(path) :
        geDialog.Enable(button, True)
        geDialog.SetString(text, "Path exists - you can now change your texture path")
        geDialog.SetDefaultColor(text, c4d.COLOR_TEXT, c4d.Vector(0, 50, 0))   
    else:
        geDialog.Enable(button, False) 
        geDialog.SetString(text, "Path doesn't exist - please enter a valid path")
        geDialog.SetDefaultColor(text, c4d.COLOR_TEXT, c4d.Vector(200, 0, 0))   

############################################################
# recursive function where we do stuff to the shaders
############################################################
def shadertree(shader,path):
    # Loop through the BaseList
    while(shader):         

        # This is where you do stuff
        # If it's a bitmap, we'll look at the filename

        if shader.GetType() == c4d.Xbitmap:
                   
            filename = shader[c4d.BITMAPSHADER_FILENAME]  
                  
            
            # for instance we can set the filename to just the file part
            filename = os.path.basename(filename)
            if path == "":
                shader[c4d.BITMAPSHADER_FILENAME] = filename
            else:
                shader[c4d.BITMAPSHADER_FILENAME] = path+"\\"+filename                           
            
         
        # Check for child shaders & recurse
        if shader.GetDown(): shadertree(shader.GetDown(), path)
        # Get the Next Shader
        shader = shader.GetNext() 
         
############################################################
# replaceTexturepath
############################################################
def replaceTexturepath(path):
    # Get the first material
    doc= c4d.documents.GetActiveDocument()
    mat = doc.GetFirstMaterial()
    # Loop through materials
    while(mat):       
        # Get the first shader
        # Note - this is a 4D list - you've gotta GetDown
        shd = mat.GetFirstShader()
        # Use our recursive function to parse the shader tree
        shadertree(shd, path)
        #print shd
        # Get the Next material
        mat = mat.GetNext()